SoGLMultiTextureImageElement Class Reference

| http://www.sim.no/ http://www.coin3d.org/

- Main Page
- Related Pages
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
SoGLMultiTextureImageElement Class Reference
Element Classes

The SoGLMultiTextureImageElement is used to control the current GL texture for texture units. More...

`#include <Inventor/elements/SoGLMultiTextureImageElement.h>`

Inheritance diagram for SoGLMultiTextureImageElement:

## Public Member Functions
virtual void | init (SoState *state)
| FIXME: write doc.
virtual void | push (SoState *state)
virtual void | pop (SoState *state, const SoElement *prevTopElement)
Public Member Functions inherited from SoMultiTextureImageElement
virtual SbBool | matches (const SoElement *elem) const
SoElement * | copyMatchInfo (void) const
virtual void | setElt (const int unit, const uint32_t nodeid, const SbVec2s &size, const int numComponents, const unsigned char *bytes, const SoTextureImageElement::Wrap wrapS, const SoTextureImageElement::Wrap wrapT, const SoTextureImageElement::Model model, const SbColor &blendColor)
| FIXME: write doc.
virtual void | setElt (const int unit, const uint32_t nodeid, const SbVec3s &size, const int numComponents, const unsigned char *bytes, const SoTextureImageElement::Wrap wrapS, const SoTextureImageElement::Wrap wrapT, const SoTextureImageElement::Wrap wrapR, const SoTextureImageElement::Model model, const SbColor &blendColor)
Public Member Functions inherited from SoElement
const SoType | getTypeId (void) const
int | getStackIndex (void) const
void | setDepth (const int depth)
int | getDepth (void) const
virtual void | print (FILE *file=stdout) const
virtual | ~SoElement ()

## Static Public Member Functions
static SoType | getClassTypeId (void)
static int | getClassStackIndex (void)
static void * | createInstance (void)
static void | initClass (void)
static void | set (SoState *const state, SoNode *const node, const int unit, SoGLImage *image, const SoTextureImageElement::Model model, const SbColor &blendColor)
static void | restore (SoState *state, const int unit)
static SoGLImage * | get (SoState *state, const int unit, SoTextureImageElement::Model &model, SbColor &blendcolor)
static SbBool | hasTransparency (SoState *state)
Static Public Member Functions inherited from SoMultiTextureImageElement
static SoType | getClassTypeId (void)
static int | getClassStackIndex (void)
static void * | createInstance (void)
static void | initClass (void)
static void | setDefault (SoState *const state, SoNode *const node, const int unit)
static void | set (SoState *const state, SoNode *const node, const int unit, const SbVec2s &size, const int numComponents, const unsigned char *bytes, const SoTextureImageElement::Wrap wrapS, const SoTextureImageElement::Wrap wrapT, const SoTextureImageElement::Model model, const SbColor &blendColor)
| FIXME: write doc.
static void | set (SoState *const state, SoNode *const node, const int unit, const SbVec3s &size, const int numComponents, const unsigned char *bytes, const SoTextureImageElement::Wrap wrapS, const SoTextureImageElement::Wrap wrapT, const SoTextureImageElement::Wrap wrapR, const SoTextureImageElement::Model model, const SbColor &blendColor)
static const unsigned char * | get (SoState *const state, const int unit, SbVec2s &size, int &numComponents, SoTextureImageElement::Wrap &wrapS, SoTextureImageElement::Wrap &wrapT, SoTextureImageElement::Model &model, SbColor &blendColor)
| FIXME: write doc.
static const unsigned char * | get (SoState *const state, const int unit, SbVec3s &size, int &numComponents, SoTextureImageElement::Wrap &wrapS, SoTextureImageElement::Wrap &wrapT, SoTextureImageElement::Wrap &wrapR, SoTextureImageElement::Model &model, SbColor &blendColor)
static const unsigned char * | getImage (SoState *const state, const int unit, SbVec2s &size, int &numComponents)
static const unsigned char * | getImage (SoState *const state, const int unit, SbVec3s &size, int &numComponents)
static const SbColor & | getBlendColor (SoState *const state, const int unit)
static SoTextureImageElement::Model | getModel (SoState *const state, const int unit)
static SoTextureImageElement::Wrap | getWrapS (SoState *const state, const int unit)
static SoTextureImageElement::Wrap | getWrapT (SoState *const state, const int unit)
static SoTextureImageElement::Wrap | getWrapR (SoState *const state, const int unit)
static SbBool | containsTransparency (SoState *const state)
| FIXME: write doc.
static const unsigned char * | getDefault (SbVec2s &size, int &numComponents)
| FIXME: write doc.
static const unsigned char * | getDefault (SbVec3s &size, int &numComponents)
Static Public Member Functions inherited from SoElement
static void | initClass (void)
static SoType | getClassTypeId (void)
static int | getClassStackIndex (void)
static void | initElements (void)
static int | getNumStackIndices (void)
static SoType | getIdFromStackIndex (const int stackIndex)

## Protected Member Functions
virtual | ~SoGLMultiTextureImageElement ()
virtual SbBool | hasTransparency (const int unit) const
Protected Member Functions inherited from SoMultiTextureImageElement
virtual | ~SoMultiTextureImageElement ()
const UnitData & | getUnitData (const int unit) const
Protected Member Functions inherited from SoElement
| SoElement (void)
void | capture (SoState *const state) const
virtual void | captureThis (SoState *state) const
void | setTypeId (const SoType typeId)
void | setStackIndex (const int index)
SoElement * | getNextInStack (void) const
SoElement * | getNextFree (void) const

## Additional Inherited Members
Static Protected Member Functions inherited from SoElement
static SoElement * | getElement (SoState *const state, const int stackIndex)
static const SoElement * | getConstElement (SoState *const state, const int stackIndex)
static int | createStackIndex (const SoType id)
Protected Attributes inherited from SoElement
SoType | typeId
int | stackIndex
int | depth
Static Protected Attributes inherited from SoElement
static int | classStackIndex
static SoTypeList * | stackToType

## Detailed Description

The SoGLMultiTextureImageElement is used to control the current GL texture for texture units.

## Constructor & Destructor Documentation

SoGLMultiTextureImageElement::~SoGLMultiTextureImageElement | ( | void |  | ) |
| protectedvirtual

The destructor.

## Member Function Documentation

void * SoGLMultiTextureImageElement::createInstance | ( | void |  | ) |
| static

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

void SoGLMultiTextureImageElement::initClass | ( | void |  | ) |
| static

This static method initializes static data in the SoGLMultiTextureImageElement class.

void SoGLMultiTextureImageElement::push | ( | SoState * | state | ) |
| virtual

This method is called every time a new element is required in one of the stacks. This happens when a writable element is requested, using SoState::getElement() or indirectly SoElement::getElement(), and the depth of the current element is less than the state depth.

Override this method if your element needs to copy data from the previous top of stack. The push() method is called on the new element, and the previous element can be found using SoElement::getNextInStack().

Reimplemented from SoMultiTextureImageElement.

void SoGLMultiTextureImageElement::pop | ( | SoState * | state,
|  | const SoElement * | prevTopElement
| ) |  |
| virtual

This method is callled when the state is popped, and the depth of the element is bigger than the current state depth. pop() is called on the new top of stack, and a pointer to the previous top of stack is passed in prevTopElement.

Override this method if you need to copy some state information from the previous top of stack.

Reimplemented from SoElement.

void SoGLMultiTextureImageElement::set | ( | SoState *const | state,
|  | SoNode *const | node,
|  | const int | unit,
|  | SoGLImage * | image,
|  | const SoTextureImageElement::Model | model,
|  | const SbColor & | blendColor
| ) |  |
| static

Sets the current texture. Id didapply is TRUE, it is assumed that the texture image already is the current GL texture. Do not use this feature unless you know what you're doing.

SbBool SoGLMultiTextureImageElement::hasTransparency | ( | SoState * | state | ) |
| static

Returns TRUE if any of the images have at least one transparent pixel.

Since
  Coin 3.1

SbBool SoGLMultiTextureImageElement::hasTransparency | ( | const int | unit | ) | const
| protectedvirtual

Called by containsTransparency(). Returns TRUE if image data has transparency. Default method does a very poor job of detecting this, since it returns TRUE when the number of components are 2 or

1. Override whenever it is important to know this (SoGLTextureImageElement overrides it to avoid transparency handling where possible).

Reimplemented from SoMultiTextureImageElement.

The documentation for this class was generated from the following files:

- SoGLMultiTextureImageElement.h
- SoGLMultiTextureImageElement.cpp

Copyright © 1998-2010 by Kongsberg Oil & Gas Technologies. All rights reserved.